.386

.model flat, stdcall 
option casemap :none 

include \MASM32\INCLUDE\windows.inc
include \MASM32\INCLUDE\masm32.inc
include \MASM32\INCLUDE\gdi32.inc
include \MASM32\INCLUDE\user32.inc
include \MASM32\INCLUDE\kernel32.inc
includelib \MASM32\LIB\masm32.lib
includelib \MASM32\LIB\gdi32.lib
includelib \MASM32\LIB\user32.lib
includelib \MASM32\LIB\kernel32.lib

Handle_Info struct
	Pid			DWORD ?
	ObjectType		WORD ?
	HandleValue		WORD ?
	ObjectPointer		DWORD ?
	AccessMask		DWORD ?	
Handle_Info ends

UNICODE_STRING STRUCT
	woLength		WORD	?		; len of string in bytes (not chars)
	MaximumLength		WORD	?			; len of Buffer in bytes (not chars)
	Buffer			DWORD	?	; pointer to string
UNICODE_STRING ENDS

.data
form				db "error: %u", 0
form1				db "error1: %x", 0
form2				db "error2: %u", 0
PhysicalDrive0			db '\\.\PhysicalDrive0',0,0
perenos				db 13,10,0
ntdll				db "NTDLL.DLL",0
FuncName 			db "NtQueryObject",0

.data?
buffer				db 512 dup(?)
string				db 1536 dup(?)
_NtQueryObject			dd ?
ObjName label byte
Name				UNICODE_STRING <?>
pBuffer				db MAX_PATH+1 dup (?)

.code
start:
invoke CreateFile,addr PhysicalDrive0,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ OR FILE_SHARE_WRITE,0, OPEN_EXISTING,0,0
.if eax !=INVALID_HANDLE_VALUE
	mov ebx, eax
	invoke GetModuleHandle,addr ntdll
	invoke GetProcAddress,eax,addr FuncName
	mov _NtQueryObject,eax
	push 0		;
	push 214h	;sizeof(ObjName)
	push offset ObjName
	push 1		;ObjectNameInformation
	push ebx
	call _NtQueryObject
	.if eax==0	;StatusSuccess
		invoke MessageBoxW,0,addr [ObjName + sizeof UNICODE_STRING],0,MB_ICONASTERISK
	.else
		invoke wsprintf,addr buffer,ADDR form1,eax
		invoke MessageBox,0,addr buffer,0,MB_ICONASTERISK
	.endif
	invoke CloseHandle, ebx
.else
	invoke GetLastError
	invoke wsprintf,ADDR buffer,ADDR form,eax
	invoke MessageBox,0,addr buffer,0,MB_ICONASTERISK
.endif
invoke ExitProcess,0
end start